package com.govmade.modules.system.service;

import java.util.List;
import java.util.Map;
import java.util.Set;

import com.baomidou.mybatisplus.service.IService;
import com.govmade.common.utils.PageTreeUtils;
import com.govmade.common.utils.PageUtils;
import com.govmade.modules.system.entity.DictEntity;
import com.govmade.modules.system.entity.UserEntity;

/**
 * 系统管理 - 字典设置
 * 
 * @author Fred
 * @email fangtaosh@qq.com
 * @date 2018年8月7日
 */
public interface DictService extends IService<DictEntity> {

	DictEntity queryOne(Map<String, Object> params);
	
	List<DictEntity> queryChilds(String value);
	
	/**
	 * 树机构列表
	 */
        PageTreeUtils queryPage(Map<String, Object> params);
	
	/**
	 * 保存或修改字典
	 */
	void save(DictEntity dict);
	
	/**
	 * 检测是否重名
	 */
	Integer checkDict(String name);
	
	DictEntity queryById(Long id);
	
	/**
	 * 删除字典
	 */
	void deleteBatch(Set<Long> ids);
}
